
// Mcr Monitor.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "mcrcommon.h"
#include "Mcr Monitor.h"
#include "Mcr MonitorDlg.h"
#include "FindSync.h"
#include "PipeInterface.h"
#include "DebugOutput.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//HDDEDATA CALLBACK DdeCallback(UINT, UINT, HCONV, HSZ, HSZ, HDDEDATA, DWORD, DWORD);

CPipeInterface *hPipeInterface;

//DWORD	idInst;		// our DDE instance handle
//HCONV	ddeConv;	// our DDE conversation handle
HSZ		hszService, hszTopic;

// CMcrMonitorApp

BEGIN_MESSAGE_MAP(CMcrMonitorApp, CWinApp)
	ON_COMMAND(ID_HELP, &CWinApp::OnHelp)
END_MESSAGE_MAP()


// CMcrMonitorApp construction

CMcrMonitorApp::CMcrMonitorApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CMcrMonitorApp object

CMcrMonitorApp theApp;


// CMcrMonitorApp initialization

BOOL CMcrMonitorApp::InitInstance()
{
	OSVERSIONINFO osvi;
	BOOL bIsWindowsXPorLater;

	CFindMcrsync	*findSync;
	ATOM			singleInstance;

	//idInst     = 0;
	//ddeConv    = NULL;
	hszService = NULL;
	hszTopic   = NULL;

	#ifdef _DEBUG
	DebugInit("MCR-MON","C:\\Temp\\MCRDEBUG.TXT",DEBUG_FILE);
	#endif

	// InitCommonControlsEx() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	INITCOMMONCONTROLSEX InitCtrls;
	InitCtrls.dwSize = sizeof(InitCtrls);

	// Set this to include all the common control classes you want to use
	// in your application.
	InitCtrls.dwICC = ICC_WIN95_CLASSES;
	InitCommonControlsEx(&InitCtrls);

	CWinApp::InitInstance();


	AfxEnableControlContainer();

	// Create the shell manager, in case the dialog contains
	// any shell tree view or shell list view controls.
	CShellManager *pShellManager = new CShellManager;

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	// check to see if an instance of the app already exists

	singleInstance = GlobalFindAtom("SYNCMON_ATOM");

	if (singleInstance)
	{
#ifndef _DEBUG
		::MessageBoxEx(	NULL,
						"You may run only one instance of this application at a time.\r\nIf another instance is running please close it before continuing.\r\nIf this message occurs and no other instance is running\r\nplease restart your computer to stop this message from displaying.",
						"Error",
						MB_OK|MB_ICONEXCLAMATION,
						LANG_ENGLISH);
#else
		::MessageBoxEx(	NULL,
						"Multiple instance of app ignored - debugging",
						"Error",
						MB_OK|MB_ICONEXCLAMATION,
						LANG_ENGLISH);
#endif
	}

	singleInstance = GlobalAddAtom("SYNCMON_ATOM");

	ZeroMemory(&osvi, sizeof(OSVERSIONINFO));
	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);

	GetVersionEx(&osvi);

	bIsWindowsXPorLater =
		( (osvi.dwMajorVersion > 5) ||
		( (osvi.dwMajorVersion == 5) && (osvi.dwMinorVersion >= 1) ));

	if (!bIsWindowsXPorLater)
	{
		// once Windows 7 support is added, we no longer support any OS less than Windows XP

		// return an error

		::MessageBoxEx(	NULL,
						"This Operating System not supported.\r\nWindows XP or later required.",
						"Error",
						MB_OK|MB_ICONEXCLAMATION,
						LANG_ENGLISH);

		GlobalDeleteAtom(singleInstance);
		return(FALSE);
	}
	else
	{

		hPipeInterface = new CPipeInterface(m_lpCmdLine);

		while(!hPipeInterface->PipeConnect())
		{
			// Scan for the MCR service on the network. It was not
			// found on this PC that is running the monitor application.

			hPipeInterface->monitorSystemIsLocal = FALSE;

			findSync = new CFindMcrsync;

			if (findSync->DoModal() != IDOK)
			{
				GlobalDeleteAtom(singleInstance);
				return(FALSE);
			}

			strcpy_s(hPipeInterface->serverName,sizeof(hPipeInterface->serverName),findSync->m_NewTarget);

			delete findSync;
		}
	}


	CMcrMonitorDlg dlg;
	m_pMainWnd        = &dlg;
	INT_PTR nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		if (hPipeInterface->usePipeTransactions)
			hPipeInterface->PipeShutdown();

		GlobalDeleteAtom(singleInstance);
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
	if (hPipeInterface->usePipeTransactions)
		hPipeInterface->PipeShutdown();
	//else
	//	DDEShutdown();

		GlobalDeleteAtom(singleInstance);
		//  dismissed with Cancel
	}

	// Delete the shell manager created above.
	if (pShellManager != NULL)
	{
		delete pShellManager;
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}

CMyCommandLine::CMyCommandLine()
{

}

void CMyCommandLine::ParseParam(LPCTSTR lpszParam, BOOL bFlag, BOOL bLast)
{
	#ifdef _DEBUG_INFO
	DebugMsg("%s",lpszParam);
	#endif
}



//
//		Name:			DDEConnect()
//
//		Description:	Opens a connection to MCRSYNC's DDE server on
//						the local machine.  A DDE server is
//						only present in the Windows 9x/Me implementation of
//						MCRSYNC time synchronization service.
//

//BOOL DDEConnect(void)
//{
//	UINT	retCode;
//
//	// initialize DDE
//
//	#ifdef _DEBUG_INFO
//	DebugMsg("DDE connect");
//	#endif
//
//	idInst = 0;
//
//	retCode = DdeInitialize(&idInst,(PFNCALLBACK)DdeCallback,
//		APPCLASS_STANDARD|APPCMD_CLIENTONLY,0);
//
//	if (retCode != DMLERR_NO_ERROR)
//	{
//		#ifdef _DEBUG_ERROR
//		DebugMsg("!!!DdeInitialize() error: %u",retCode);
//		#endif
//		return(FALSE);
//	}
//
//	// initialize a conversation with DDE server
//
//	hszService = DdeCreateStringHandle(idInst,MCRSYNC_IPC_NAME,CP_WINANSI);
//	hszTopic   = DdeCreateStringHandle(idInst,"n/a",CP_WINANSI);
//
//	ddeConv    = DdeConnect(idInst,hszService,hszTopic,NULL);
//
//	if (!ddeConv)
//	{
//		#ifdef _DEBUG_ERROR
//		DebugMsg("!!!DdeConnect() error: %u",DdeGetLastError(idInst));
//		#endif
//		return(FALSE);
//	}
//
//	return(TRUE);
//}


//
//		Name:			DDETransaction()
//
//		Description:	Sends a transaction to the DDE server in the MCRSYNC
//						service running Win 9x/Me.
//

//BOOL DDETransaction(char *item, LPBYTE buffer, DWORD bufSize)
//{
//	HSZ			hszItem;
//	DWORD		convResult;
//	HDDEDATA	ddeData;
//	BOOL		retVal;
//
//	#ifdef _DEBUG_INFO
//	DebugMsg("DDEClientTransaction() sending %s", item);
//	#endif
//
//	hszItem = DdeCreateStringHandle(idInst,item,CP_WINANSI);
//
//	ddeData = DdeClientTransaction(	NULL,
//									0,
//									ddeConv,
//									hszItem,
//									CF_TEXT,
//									XTYP_REQUEST,
//									1000,
//									&convResult);
//
//    if (ddeData)
//	{
//		#ifdef _DEBUG_INFO
//		DebugMsg("DDEClientTransaction() %s succeeded",item);
//		#endif
//		DdeGetData(ddeData,buffer,bufSize,0L);
//		DdeFreeDataHandle(ddeData);
//
//		retVal = TRUE;
//	}
//	else
//	{
//		#ifdef _DEBUG_ERROR
//		DebugMsg("!!!DDEClientTransaction() %s failed with error=%u",item,(int)DdeGetLastError(idInst));
//		#endif
//		retVal = FALSE;
//	}
//
//	DdeFreeStringHandle(idInst,hszItem);
//
//	return(retVal);
//}


//
//		Name:			DDEShutdown()
//
//		Description:	Closes all handles related to our persistent DDE
//						connection.
//

//void DDEShutdown(void)
//{
//	#ifdef _DEBUG_INFO
//	DebugMsg("DDE disconnect");
//	#endif
//
//	DdeFreeStringHandle(idInst,hszTopic);
//	DdeFreeStringHandle(idInst,hszService);
//
//	DdeDisconnect(ddeConv);
//	DdeUninitialize(idInst);
//}


//HDDEDATA CALLBACK DdeCallback(
//    UINT uType,	// transaction type
//    UINT uFmt,	// clipboard data format
//    HCONV hconv,	// handle to the conversation
//    HSZ hsz1,	// handle to a string
//    HSZ hsz2,	// handle to a string
//    HDDEDATA hdata,	// handle to a global memory object
//    DWORD dwData1,	// transaction-specific data
//    DWORD dwData2 	// transaction-specific data
//   )
//{
//	//#ifdef _DEBUG_INFO
//	//	DebugMsg("uType=%u uFmt=%u hconv=%u hsz1=%u hsz2=%u hdata=%u dwData1=%lu dwData2=%lu",
//	//		uType,uFmt,hconv,hsz1,hsz2,hdata,dwData1,dwData2);
//	//#endif
//	#ifdef _DEBUG_INFO
//	DebugMsg("DDE callback");
//	#endif
//
//	return(hdata);
//}
