
// Mcr MonitorDlg.h : header file
//

#pragma once
#include "afxwin.h"


// CMcrMonitorDlg dialog
class CMcrMonitorDlg : public CDialogEx
{
// Construction
public:
	CMcrMonitorDlg(CWnd* pParent = NULL);	// standard constructor
	~CMcrMonitorDlg();

	static DWORD			m_dwHelpMap[];

	DWORD					cbReturned;
	HANDLE					h_PollTimeThread;
	DWORD					dwThreadId;
	DWORD					curInterruptFreq;

	MCRSYNC_IPC_VERSION		syncVersion;
	MCRSYNC_IPC_CURTIME		syncCurTime;
	MCRSYNC_IPC_SYNCHIST	syncHist, syncHistOld;
	MCRSYNC_IPC_INFO        syncInfo;

	MCRSYNC_IPC_FIRMWARE_VERSION	syncFirmwareVersion; // kpw
	API_LAST_LOCK_STATUS	syncLockStatus;

// Dialog Data
	enum { IDD = IDD_MCR_MONITOR_DIALOG };
	CListBox	m_SyncHist;
	CStatic	m_Monitoring;
	CStatic display_McrRead_Time;
	CStatic display_McrRead_Date;
	CStatic display_UTC_Time;
	CStatic display_UTC_Date;
	CStatic display_System_Time;
	CStatic display_System_Date;
	CStatic display_mcrsync_Version;
	CStatic display_Time_Status;

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnDestroy();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedRecalibrate();
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedCancel();
	afx_msg void OnBnClickedSetTime();
	CStatic display_mcrsync_FirmwareVersion;
	CStatic display_mcrsync_HSO_Status;
	CStatic display_mcrsync_HSO_Level;

	// kpw - these are from AVR code, in McrSerialProtocol.h
	#define LOCK_INVALID         0x00   // never had a lock
	#define LOCK_NOT_PRESENT     0x01   // had a lock but lost it
	#define LOCK_LOST            0x02   // notify, one time, that lock was lost
	#define LOCK_RESTORED        0x03   // notify, one time, that lock was restored
	#define LOCK_PRESENT         0x04   // currently locked to a reference

	#define HSO_NOT_INSTALLED    0x05   // kpw 1.0.3 - To report to the user if an HSO is present and working.
};
